/*---------------------------------------------------------------------------
 *	fgrab_prototyp.h
 *
 *	Copyright (c) 2002-2005 Silicon Software GmbH, All Rights Reserved.
 *
 *  Contents:	Header file for all functions exported
 *
 *----------------------------------------------------------------------------
 */

#ifndef __FGRAB_PROTOTYP_H
#define __FGRAB_PROTOTYP_H


#include "fgrab_struct.h"

//#ifdef __cplusplus
extern "C" {
//#endif

int Info(int cmd,int sub_cmd,int sub_cmd2,void *param,void **param2);
Fg_Struct* Fg_InitCamera(char *DLL_Name,int mEnableNr);
Fg_Struct* Fg_InitLocal(int BoardNr,int ext_size,int *err);
Fg_Struct* Fg_Init(char *DLL_Name,int mEnableNr);
Fg_Struct* Fg_InitEx(char *DLL_Name,int mEnableNr,int isSlave);
Fg_Struct* Fg_InitConfig(char *Config_Name,int NumberOfmEnable);
unsigned long *Fg_AllocMem(Fg_Struct *Fg, int Size, int Nr_Of_Buf,int CamPort);
void *Fg_AllocMemEx(Fg_Struct *Fg, int Size, int Nr_Of_Buf);
int Fg_configure(Fg_Struct *Fg, int AppletId);
char *Fg_getAppletname (Fg_Struct *Fg,int AppletId);
int Fg_getAppletId(Fg_Struct *Fg,char * Appletname);
int Fg_setParameter(Fg_Struct *Fg,int Parameter,void *Value,int CamPort);
int Fg_getParameter(Fg_Struct *Fg,int Parameter,void *Value,int CamPort);
int Fg_getParameterEx(Fg_Struct *Fg,int Parameter,void *Value,int CamPort,void *pMem,int Data);
int Fg_saveConfig(Fg_Struct *Fg,const char * Filename);
int Fg_loadConfig(Fg_Struct *Fg,const char * Filename);
int Fg_Acquire(Fg_Struct *Fg,int CamPort ,int PicCount);
int Fg_stopAcquire(Fg_Struct *Fg,int CamPort);
int Fg_sendSoftwareTrigger(Fg_Struct *Fg,int CamPort);
int Fg_getLastPicNumberBlocking(Fg_Struct *Fg,int PicNr,int CamPort,int Timeout);
int Fg_getLastPicNumber(Fg_Struct *Fg,int CamPort);
int Fg_getLastPicNumberBlockingEx(Fg_Struct *Fg,int PicNr,int CamPort,int Timeout,void *pMem);
int Fg_getLastPicNumberEx(Fg_Struct *Fg,int CamPort,void *pMem);
int Fg_setActBuffer (Fg_Struct *Fg,int BufferNr,int CamPort);
int Fg_getActBuffer (Fg_Struct *Fg,int CamPort);
int Fg_swapBuffer (Fg_Struct *Fg,int CamPort);
int Fg_FreeGrabber(Fg_Struct *Fg);
int Fg_FreeMem(Fg_Struct *Fg,int CamPort);
int Fg_FreeMemEx(Fg_Struct *Fg,void *mem);
int Fg_getLastErrorNumber(Fg_Struct *Fg);
char *Fg_getLastErrorDescription(Fg_Struct *Fg);
char *Fg_getErrorDescription(Fg_Struct *Fg,int ErrorNumber);
long Fg_getSerialNumber(Fg_Struct *Fg);
unsigned long *Fg_getImagePtr(Fg_Struct *Fg,int PicNr,int CamPort);
unsigned long *Fg_getImagePtrEx(Fg_Struct *Fg,int PicNr,int CamPort,void *pMem);
int Fg_doDialog(Fg_Struct *Fg,int Dummy,int Parent,int CamPort,DialogInterface Dialogpara);
int Fg_closeDialog(Fg_Struct *Fg);
int Fg_isOpenDialog(Fg_Struct *Fg);
int getLastErrorNumber();
char *getErrorDescription(int ErrorNumber);

void*			Fg_AllocMemHead	(Fg_Struct *Fg,int Size, int Nr_Of_Buf);
int				Fg_FreeMemHead	(Fg_Struct *Fg,void *memHandle);
int				Fg_AddMem		(Fg_Struct *Fg,unsigned char* pBuffer,int Size, int Nr_Of_Buf,void *memHandle);
int				Fg_DelMem		(Fg_Struct *Fg,void *memHandle,int bufferIndex);
void*			Fg_AddDummyBuffer(Fg_Struct *Fg,unsigned char* pBuffer,int Size,void *memHandle);
int				Fg_getStatus	(Fg_Struct *Fg,int Param,int nData,int CamPort);
int				Fg_getStatusEx	(Fg_Struct *Fg,int Param,int nData,int CamPort,void *pMem);
int				Fg_setStatus	(Fg_Struct *Fg,int Param,int Data,int CamPort);
int				Fg_setStatusEx	(Fg_Struct *Fg,int Param,int Data,int CamPort,void *pMem);
int				Fg_AcquireEx	(Fg_Struct *Fg,int CamPort,int PicCount,int nFlag,void *memHandle);
int				Fg_AcquireAPCEx(Fg_Struct *Fg,int CamPort,int PicCount,int nFlag,void *memHandle,Fg_AcquireHandler apcfunc,void *data);
int				Fg_stopAcquireEx(Fg_Struct *Fg,int CamPort,void *memHandle,int nFlag);
int				Fg_setExsync	(Fg_Struct *Fg,int Flag,int CamPort);
int				Fg_setFlash	(Fg_Struct *Fg,int Flag,int CamPort);
int             Fg_getImage		(Fg_Struct *Fg,int Param,int Pic_Nr,int CamPort,int Timeout);
int             Fg_getImageEx	(Fg_Struct *Fg,int Param,int Pic_Nr,int CamPort,int Timeout,void *pMem);

void*			Fg_AllocShading(Fg_Struct *Fg,int set,int port);
int				Fg_FreeShading(Fg_Struct *Fg,void* sh);
int				Shad_SetSubValueLine (Fg_Struct *Fg,void* sh,int x,int channel,float sub);
int				Shad_SetMultValueLine(Fg_Struct *Fg,void* sh,int x,int channel,float mult);
int				Shad_SetFixedPatternNoiseLine(Fg_Struct *Fg,void* sh,int x,int channel,int on);
int				Shad_GetMaxLine		(Fg_Struct *Fg,void* sh);
int				Shad_GetAccess		(Fg_Struct *Fg,void* sh);
int				Shad_FreeAccess		(Fg_Struct *Fg,void* sh);
int				Shad_WriteActLine	(Fg_Struct *Fg,void* sh,int Line);
//////////////////////////////////////////////////////////////
// Display Funktionen

int  CreateDisplay	(int nColor,int nWidth,int nHeight);
void SetBufferWidth	(int nId,int nWidth,int nHeight);
void DrawBuffer		(int nId,unsigned long *ulpBuf,int nNr,char *cpStr);
void CloseDisplay	(int nId);



//#ifdef __cplusplus
}
//#endif

#endif

